@mixin word-wrap {
  word-wrap: break-word;
  overflow-wrap: break-word;
  hyphens: auto;
}

.word-wrap {
  @include word-wrap;
}

.display-as-block {
  display: block;
}

@mixin multiline-ellipsis($block-line-height) {
  height: $block-line-height;
}

@mixin fontapercu {
  font-family: 'Apercu Pro', Helvetica, Roboto, Arial, sans-serif;
  text-rendering: optimizeLegibility;
  -webkit-font-smoothing: antialiased;
  font-weight: bold;
  font-size: $fontsize-xs;
  letter-spacing: .01rem;
  font-style: normal;
}

@mixin fontsectraitalic {
  font-family: 'Sectra Book Italic', 'Times', 'Vollkorn', serif;
  text-rendering: optimizeLegibility;
  -webkit-font-smoothing: antialiased;
  font-weight: normal;
}

@mixin fontsectra {
  font-family: 'Sectra Book', 'Times', 'Vollkorn', serif;
  text-rendering: optimizeLegibility;
  -webkit-font-smoothing: antialiased;
  font-weight: normal;
}

@mixin fontsectramedium {
  font-family: 'Sectra Medium', 'Times', 'Vollkorn', serif;
  text-rendering: optimizeLegibility;
  -webkit-font-smoothing: antialiased;
  font-weight: normal;
}

@mixin fontsectramediumitalic {
  font-family: 'Sectra Medium Italic', 'Times', 'Vollkorn', serif;
  text-rendering: optimizeLegibility;
  -webkit-font-smoothing: antialiased;
  font-weight: normal;
}

@mixin no-wrap { white-space: nowrap; }

// FONT FAMILY DECLARATIONS

.font-sectra-medium {
  @include fontsectramedium;
}

.font-sectra-medium-italic {
  @include fontsectramediumitalic;
}

.font-sectra-italic {
  &,
  & * {
    @include fontsectraitalic;
  }

  & strong,
  & b {
    font-weight: bold;
  }
}

.font-sectra {
  @include fontsectra;
}

.font-apercu {
  @include fontapercu;
}

$gutters: $gutter-xl, $gutter-l, $gutter-m, $gutter-sm, $gutter-s, 0;

$gutter-names: 'xl', 'l', 'm', 'sm', 's', '0';

$orientations: 'top', 'bottom', 'left', 'right';

@for $i from 1 through length($gutters) {
  $this-gutter: nth($gutter-names, $i);
  @for $j from 1 through length($orientations) {
    $this-orientation: nth($orientations, $j);

    .pad-#{$this-orientation}-#{$this-gutter} {
      padding-#{$this-orientation}: nth($gutters, $i);
    }

    .mar-#{$this-orientation}-#{$this-gutter} {
      margin-#{$this-orientation}: nth($gutters, $i);
    }
  }
}

@for $i from 1 through length($gutters) {
  $this-gutter: nth($gutter-names, $i);

  .pad-#{$this-gutter} {
    padding: nth($gutters, $i);
  }

  .mar-#{$this-gutter} {
    margin: nth($gutters, $i);
  }
}

@mixin position($position, $args: ()) {
  $offsets: top right bottom left;
  position: $position;                                               // 1

  @each $offset in $offsets {                                        // 3
    $index: index($args, $offset);                                   // 4

    @if $index {                                                     // 5
      @if $index == length($args) {                                  // 6
        #{$offset}: 0;                                               // 7
      } @else {                                                  // 8
        $next: nth($args, $index + 1);                               // 9
        @if is-valid-length($next) {                                 // 10
          #{$offset}: $next;                                         // 11
        }
        @else if index($offsets, $next) {                            // 12
          #{$offset}: 0;                                             // 13
        }
      }
    }
  }
}

@function is-valid-length($length-value) {
  @return (type-of($length-value) == 'number' and not unitless($length-value)) or (index(auto initial inherit 0, $length-value) != false);
}

@mixin absolute($args: ()) {
  @include position(absolute, $args);
}

@mixin fixed($args: ()) {
  @include position(fixed, $args);
}

@mixin relative($args: ()) {
  @include position(relative, $args);
}

.reveal {
  .reveal-label {
    display: inline-block;
  }

  .reveal-toggle {
    position: absolute;
    left: -1 * 999em;
  }

  .reveal-content {
    will-change: opacity, max-height, height;
    opacity: 0;
    max-height: 0;
    border: 0;
    overflow: hidden;
    transition: opacity .34s ease-in, max-height 1.5s linear;
  }

  .reveal-toggle[type='checkbox']:checked {
    & ~ div {
      max-height: 99em;
      opacity: 1;
      height: auto;
    }

    & + .reveal-label {
      display: none;
    }
  }
}

$gutters: $gutter-xl, $gutter-l, $gutter-m, $gutter-sm, $gutter-s, 0;   // 0px

$gutter-names: 'xl', 'l', 'm', 'sm', 'S', '0';

$orientations: 'top', 'bottom', 'left', 'right';

@for $i from 1 through length($gutters) {
  $this-gutter: nth($gutter-names, $i);
  @for $j from 1 through length($orientations) {
    $this-orientation: nth($orientations, $j);

    .pad-#{$this-orientation}-#{$this-gutter} {
      padding-#{$this-orientation}: nth($gutters, $i);
    }

    .mar-#{$this-orientation}-#{$this-gutter} {
      margin-#{$this-orientation}: nth($gutters, $i);
    }
  }
}

@for $i from 1 through length($gutters) {
  $this-gutter: nth($gutter-names, $i);

  .pad-#{$this-gutter} {
    padding: nth($gutters, $i);
  }

  .mar-#{$this-gutter} {
    margin: nth($gutters, $i);
  }
}

@mixin position($position, $args: ()) {
  $offsets: top right bottom left;
  position: $position;                                               // 1

  @each $offset in $offsets {                                        // 3
    $index: index($args, $offset);                                   // 4

    @if $index {                                                     // 5
      @if $index == length($args) {                                  // 6
        #{$offset}: 0;                                               // 7
      } @else {                                                        // 8
        $next: nth($args, $index + 1);                               // 9
        @if is-valid-length($next) {                                 // 10
          #{$offset}: $next;                                         // 11
        } @else if index($offsets, $next) {                            // 12
          #{$offset}: 0;                                             // 13
        }
      }
    }
  }
}

@function is-valid-length($length-value) {
  @return (type-of($length-value) == 'number' and not unitless($length-value)) or (index(auto initial inherit 0, $length-value) != false);
}

@mixin absolute($args: ()) {
  @include position(absolute, $args);
}

@mixin fixed($args: ()) {
  @include position(fixed, $args);
}

@mixin relative($args: ()) {
  @include position(relative, $args);
}

.bg-image-cover {
  background-size: cover;
}

.text-xs-right {
  text-align: right;
}

.text-uppercase {
  text-transform: uppercase;
}

.text-lowercase {
  text-transform: lowercase;
}

.text-no-transform {
  text-transform: none;
}

.pos-rel {
  position: relative;
}

.pos-abs {
  @include absolute;
}

.pos-abs-t {
  @include absolute(top 0)
}

.pos-abs-t-r {
  @include absolute(top 0 right 0)
}

.pos-abs-t-0-r-0-b-0 {
  @include absolute(top 0 right 0 bottom 0)
}

.pos-abs-t-0-l-0-r-0-b-0 {
  @include absolute(top 0 left 0 right 0 bottom 0)
}

.pos-abs-r-0-b-0 {
  @include absolute(right 0 bottom 0)
}

.pos-abs-all-s {
  @include absolute(top $gutter-s right $gutter-s bottom $gutter-s left $gutter-s);
}

.pos-abs-t-r-xl {
  @include absolute(top 0 right $gutter-xl)
}

.pos-abs-t-s-r-100pcnt {
  @include absolute(top $gutter-s right 100%)
}

.pos-abs-t-r-mistake {
  @include absolute(top 0 right mistake)
}

.pos-abs-t-s-r-m-b-m-l-sm {
  @include absolute(top $gutter-s right $gutter-m bottom $gutter-m left $gutter-sm)
}


.icon-space {
  &.left {
    padding-left: ($gutter-s / 2);
  }

  &.right {
    padding-right: ($gutter-s / 2);
  }

  &.top {
    padding-top: ($gutter-s / 2);
  }

  &.bottom {
    padding-bottom: ($gutter-s / 2);
  }
}


//Rotation
.rotate180 {
  transform: rotate(180deg);
  display: inline-block;
}

@mixin user-select {
  user-select: none;
}
